Index: codes/icosagcm/trunk/src/omp_para.F90
===================================================================
--- codes/icosagcm/trunk/src/omp_para.F90	(revision 294)
+++ codes/icosagcm/trunk/src/omp_para.F90	(revision 295)
@@ -5,8 +5,8 @@
 !$OMP THREADPRIVATE(omp_rank)
 
-  LOGICAL,SAVE :: omp_first
-  LOGICAL,SAVE :: omp_last
-  LOGICAL,SAVE :: omp_master
-!$OMP THREADPRIVATE(omp_first, omp_last,omp_master)
+  LOGICAL,SAVE :: is_omp_first_level
+  LOGICAL,SAVE :: is_omp_last_level
+  LOGICAL,SAVE :: is_omp_master
+!$OMP THREADPRIVATE(is_omp_first_level, is_omp_last_level,is_omp_master)
 
   INTEGER,SAVE :: ll_begin
@@ -17,16 +17,57 @@
 !$OMP THREADPRIVATE(ll_begin,ll_beginp1,ll_end,ll_endm1,ll_endp1)
   LOGICAL,SAVE :: using_openmp
-
+  
+  INTEGER,SAVE :: omp_domain_size
+  INTEGER,SAVE :: omp_domain_rank
+  INTEGER,SAVE :: omp_level_size
+  INTEGER,SAVE :: omp_level_rank
+!$OMP THREADPRIVATE( omp_domain_size, omp_level_size,omp_domain_rank,omp_level_rank)
+  LOGICAL,SAVE :: is_omp_domain_master
+  LOGICAL,SAVE :: is_omp_level_master
+!$OMP THREADPRIVATE(is_omp_domain_master,is_omp_level_master )
+  
   LOGICAL,PARAMETER :: omp_by_domain=.TRUE. 
+  LOGICAL,SAVE :: is_master
+!$OMP THREADPRIVATE(is_master)
+
+
+   LOGICAL,SAVE :: is_omp_first_level_full
+   LOGICAL,SAVE :: is_omp_last_level_full
+   INTEGER,SAVE :: ll_begin_full
+   INTEGER,SAVE :: ll_beginp1_full
+   INTEGER,SAVE :: ll_end_full
+   INTEGER,SAVE :: ll_endm1_full
+   INTEGER,SAVE :: ll_endp1_full
+!$OMP THREADPRIVATE(is_omp_first_level_full,is_omp_last_level_full)   
+!$OMP THREADPRIVATE( ll_begin_full, ll_beginp1_full, ll_end_full, ll_endm1_full, ll_endp1_full)
+  PRIVATE :: is_omp_first_level_full,is_omp_last_level_full
+  PRIVATE :: ll_begin_full, ll_beginp1_full, ll_end_full, ll_endm1_full, ll_endp1_full 
+  
+
+   LOGICAL,SAVE :: is_omp_first_level_distrib
+   LOGICAL,SAVE :: is_omp_last_level_distrib
+   INTEGER,SAVE :: ll_begin_distrib
+   INTEGER,SAVE :: ll_beginp1_distrib
+   INTEGER,SAVE :: ll_end_distrib
+   INTEGER,SAVE :: ll_endm1_distrib
+   INTEGER,SAVE :: ll_endp1_distrib
+!$OMP THREADPRIVATE(is_omp_first_level_distrib,is_omp_last_level_distrib)   
+!$OMP THREADPRIVATE( ll_begin_distrib, ll_beginp1_distrib, ll_end_distrib, ll_endm1_distrib, ll_endp1_distrib)
+
+  PRIVATE :: is_omp_first_level_distrib,is_omp_last_level_distrib
+  PRIVATE :: ll_begin_distrib, ll_beginp1_distrib, ll_end_distrib, ll_endm1_distrib, ll_endp1_distrib 
+
 
 CONTAINS
 
 
-  SUBROUTINE init_omp_para
+  SUBROUTINE init_omp_para(is_mpi_master)
   USE grid_param
+  USE getin_mod
 #ifdef CPP_USING_OMP
   USE omp_lib
 #endif
   IMPLICIT NONE
+  LOGICAL, INTENT(IN) :: is_mpi_master
   INTEGER :: ll_nb,i
 
@@ -49,58 +90,85 @@
     omp_rank=OMP_GET_THREAD_NUM()
 #endif
-
-    IF (omp_by_domain) THEN
-      omp_first=.TRUE.
-      omp_last=.TRUE.
-      IF (omp_rank==0) THEN
-        omp_master=.TRUE.
-      ELSE
-        omp_master=.FALSE.
-      ENDIF
-     
-      ll_begin=1
-      ll_beginp1=2
-      ll_end=llm
-      ll_endm1=llm-1
-      ll_endp1=llm+1
-     
-    ELSE    
-    
-      omp_first=.FALSE.
-      omp_last=.FALSE.
-      omp_master=.FALSE.
-    
-      IF (omp_rank==0) THEN
-        omp_first=.TRUE.
-        omp_master=.TRUE.
-      ENDIF
-    
-      IF (omp_rank==omp_size-1) omp_last=.TRUE.
-    
-      ll_end=0
-      DO i=0,omp_rank
-        ll_begin=ll_end+1
-        ll_nb=llm/omp_size
-        IF (MOD(llm,omp_size)>i) ll_nb=ll_nb+1
-        ll_end=ll_begin+ll_nb-1
-      ENDDO
-    
-      ll_beginp1=ll_begin
-      ll_endp1=ll_end
-      ll_endm1=ll_end
-
-      IF (omp_first) ll_beginp1=ll_begin+1
-      IF (omp_last) ll_endp1=ll_endp1+1
-      IF (omp_last) ll_endm1=ll_endm1-1
-    
+    
+    is_omp_master=.FALSE.
+    is_master=.FALSE.
+      
+    IF (omp_rank==0) THEN
+      is_omp_master=.TRUE.
+      IF (is_mpi_master) is_master=.TRUE.
     ENDIF
+
+    omp_level_size=1 
+    CALL getin("omp_level_size",omp_level_size)
+    IF (MOD(omp_size,omp_level_size)/=0) THEN
+      IF (is_mpi_master) PRINT*,"omp_size /= omp_level_size x omp_domain_size  => disable omp threads on vertical layers"
+      omp_level_size=1
+    ENDIF
+    omp_domain_size=omp_size/omp_level_size
+    omp_domain_rank = omp_rank / omp_level_size    
+    omp_level_rank = MOD(omp_rank, omp_level_size)    
+    
+    IF (is_mpi_master) PRINT*,"omp_domain_size",omp_domain_size,"omp_domain_rank", omp_domain_rank
+    IF (is_mpi_master) PRINT*,"omp_level_size",omp_level_size,"omp_level_rank", omp_level_rank
+    
+    is_omp_first_level=.FALSE.
+    is_omp_last_level= .FALSE.
+    is_omp_domain_master=.FALSE.
+    is_omp_level_master=.FALSE.
+
+    IF (omp_domain_rank==0) is_omp_domain_master = .TRUE.
+    IF (omp_level_rank==0) is_omp_level_master = .TRUE.
+    IF (omp_level_rank==0) is_omp_first_level=.TRUE.
+    
+    IF (omp_level_rank==omp_level_size-1) is_omp_last_level=.TRUE.
+    
+    ll_end=0
+    DO i=0,omp_level_rank
+      ll_begin=ll_end+1
+      ll_nb=llm/omp_level_size
+      IF (MOD(llm,omp_level_size)>i) ll_nb=ll_nb+1
+      ll_end=ll_begin+ll_nb-1
+    ENDDO
+    
+    ll_beginp1=ll_begin
+    ll_endp1=ll_end
+    ll_endm1=ll_end
+
+    IF (is_omp_first_level) ll_beginp1=ll_begin+1
+    IF (is_omp_last_level) ll_endp1=ll_endp1+1
+    IF (is_omp_last_level) ll_endm1=ll_endm1-1
+    
+    
+    
+    is_omp_first_level_distrib = is_omp_first_level
+    is_omp_last_level_distrib  = is_omp_last_level
+    ll_begin_distrib           = ll_begin
+    ll_beginp1_distrib         = ll_beginp1
+    ll_end_distrib             = ll_end
+    ll_endm1_distrib           = ll_endm1
+    ll_endp1_distrib           = ll_endp1
+    
+    is_omp_first_level_full = .TRUE.
+    is_omp_last_level_full  = .TRUE.
+    ll_begin_full           = 1
+    ll_beginp1_full         = 2
+    ll_end_full             = llm
+    ll_endm1_full           = llm-1
+    ll_endp1_full           = llm+1    
+
 !$OMP END PARALLEL
 
    ELSE
      omp_size=1
+     omp_level_size=1
+     omp_domain_size=1
      omp_rank=0
-     omp_first=.TRUE.
-     omp_last=.TRUE.
-     omp_master=.TRUE.
+     omp_level_rank=0
+     omp_domain_rank=0
+     is_omp_first_level=.TRUE.
+     is_omp_last_level=.TRUE.
+     is_omp_master=.TRUE.
+     is_omp_domain_master=.TRUE.
+     is_omp_level_master=.TRUE.
      ll_begin=1
      ll_beginp1=2
@@ -108,8 +176,53 @@
      ll_endm1=llm-1
      ll_endp1=llm+1
+     
+     is_omp_first_level_distrib = is_omp_first_level
+     is_omp_last_level_distrib  = is_omp_last_level
+     ll_begin_distrib           = ll_begin
+     ll_beginp1_distrib         = ll_beginp1
+     ll_end_distrib             = ll_end
+     ll_endm1_distrib           = ll_endm1
+     ll_endp1_distrib           = ll_endp1
+    
+     is_omp_first_level_full = .TRUE.
+     is_omp_last_level_full  = .TRUE.
+     ll_begin_full           = 1
+     ll_beginp1_full         = 2
+     ll_end_full             = llm
+     ll_endm1_full           = llm-1
+     ll_endp1_full           = llm+1    
+
    ENDIF
    
   END SUBROUTINE init_omp_para
 
+
+  SUBROUTINE switch_omp_distrib_level
+  IMPLICIT NONE
+     is_omp_first_level = is_omp_first_level_distrib 
+     is_omp_last_level  = is_omp_last_level_distrib 
+     ll_begin           = ll_begin_distrib 
+     ll_beginp1         = ll_beginp1_distrib 
+     ll_end             = ll_end_distrib 
+     ll_endm1           = ll_endm1_distrib 
+     ll_endp1           = ll_endp1_distrib 
+  
+  END SUBROUTINE switch_omp_distrib_level
+  
+
+  SUBROUTINE switch_omp_no_distrib_level
+  IMPLICIT NONE
+
+     is_omp_first_level = is_omp_first_level_full 
+     is_omp_last_level  = is_omp_last_level_full 
+     ll_begin           = ll_begin_full 
+     ll_beginp1         = ll_beginp1_full 
+     ll_end             = ll_end_full 
+     ll_endm1           = ll_endm1_full 
+     ll_endp1           = ll_endp1_full 
+  
+  END SUBROUTINE switch_omp_no_distrib_level
+  
+
   FUNCTION omp_in_parallel()
 #ifdef CPP_USING_OMP
Index: codes/icosagcm/trunk/src/physics.f90
===================================================================
--- codes/icosagcm/trunk/src/physics.f90	(revision 294)
+++ codes/icosagcm/trunk/src/physics.f90	(revision 295)
@@ -10,4 +10,5 @@
   TYPE(t_field),POINTER :: f_extra_physics_2D(:), f_extra_physics_3D(:)
   TYPE(t_field),POINTER :: f_dulon(:), f_dulat(:)
+  TYPE(t_field),POINTER :: f_temp(:)
 
   CHARACTER(LEN=255) :: physics_type
@@ -38,4 +39,5 @@
        CALL allocate_field(f_dulon,field_t,type_real,llm, name='dulon')
        CALL allocate_field(f_dulat,field_t,type_real,llm, name='dulat')
+       CALL allocate_field(f_temp,field_t,type_real,llm, name='temp')
        CALL init_pack_before ! Compute physics_inout%ngrid and offsets used by pack/unpack
        CALL init_physics_dcmip
@@ -102,4 +104,5 @@
     USE physics_interface_mod
     USE physics_dcmip_mod, ONLY : full_physics_dcmip => full_physics
+    USE theta2theta_rhodz_mod
     USE mpipara
     IMPLICIT NONE
@@ -111,4 +114,5 @@
     REAL(rstd),POINTER :: phis(:)
     REAL(rstd),POINTER :: ps(:)
+    REAL(rstd),POINTER :: temp(:,:)
     REAL(rstd),POINTER :: theta_rhodz(:,:)
     REAL(rstd),POINTER :: ue(:,:)
@@ -118,4 +122,6 @@
     INTEGER :: it, ind
 
+    CALL theta_rhodz2temperature(f_ps,f_theta_rhodz,f_temp)
+
     DO ind=1,ndomain
        IF (.NOT. assigned_domain(ind)) CYCLE
@@ -124,8 +130,8 @@
        phis=f_phis(ind)
        ps=f_ps(ind)
-       theta_rhodz=f_theta_rhodz(ind)
+       temp=f_temp(ind)
        ue=f_ue(ind)
        q=f_q(ind)
-       CALL pack_physics(pack_info(ind), phis, ps, theta_rhodz, ue, q)
+       CALL pack_physics(pack_info(ind), phis, ps, temp, ue, q)
     END DO
 
@@ -134,5 +140,5 @@
        CALL full_physics_dcmip
     CASE DEFAULT
-       IF(is_mpi_root) PRINT *,'Internal error : illegal value of phys_type', phys_type
+       IF(is_mpi_master) PRINT *,'Internal error : illegal value of phys_type', phys_type
        STOP
     END SELECT
@@ -143,10 +149,11 @@
        CALL swap_geometry(ind)
        ps=f_ps(ind)
-       theta_rhodz=f_theta_rhodz(ind)
+       temp=f_temp(ind)
        q=f_q(ind)
        dulon=f_dulon(ind)
        dulat=f_dulat(ind)
-       CALL unpack_physics(pack_info(ind), ps, theta_rhodz, q, dulon, dulat)
+       CALL unpack_physics(pack_info(ind), ps, temp, q, dulon, dulat)
     END DO
+    CALL temperature2theta_rhodz(f_ps,f_temp,f_theta_rhodz)
 
     ! Transfer dulon, dulat
@@ -166,5 +173,5 @@
   END SUBROUTINE physics_column
 
-  SUBROUTINE pack_physics(info, phis, ps, theta_rhodz, ue, q)
+  SUBROUTINE pack_physics(info, phis, ps, temp, ue, q)
     USE icosa
     USE wind_mod
@@ -176,16 +183,16 @@
     REAL(rstd) :: phis(iim*jjm)
     REAL(rstd) :: ps(iim*jjm)
-    REAL(rstd) :: theta_rhodz(iim*jjm,llm)
+    REAL(rstd) :: temp(iim*jjm,llm)
     REAL(rstd) :: ue(3*iim*jjm,llm)
     REAL(rstd) :: q(iim*jjm,llm,nqtot)
 
     REAL(rstd) :: p(iim*jjm,llm+1)
-    REAL(rstd) :: Temp(iim*jjm,llm)
     REAL(rstd) :: uc(iim*jjm,3,llm)
     REAL(rstd) :: ulon(iim*jjm,llm)
     REAL(rstd) :: ulat(iim*jjm,llm)
 
+!$OMP BARRIER
     CALL compute_pression(ps,p,0)
-    CALL compute_theta_rhodz2temperature(ps,theta_rhodz,Temp,0)
+!$OMP BARRIER
     CALL compute_wind_centered(ue,uc)
     CALL compute_wind_centered_lonlat_compound(uc, ulon, ulat)
@@ -199,5 +206,5 @@
   END SUBROUTINE pack_physics
 
-  SUBROUTINE unpack_physics(info, ps,theta_rhodz, q, dulon, dulat)
+  SUBROUTINE unpack_physics(info, ps,temp, q, dulon, dulat)
     USE icosa
     USE physics_interface_mod
@@ -206,6 +213,5 @@
     TYPE(t_pack_info) :: info
     REAL(rstd) :: ps(iim*jjm)
-    REAL(rstd) :: theta_rhodz(iim*jjm,llm)
-    REAL(rstd) :: Temp(iim*jjm,llm)
+    REAL(rstd) :: temp(iim*jjm,llm)
     REAL(rstd) :: q(iim*jjm,llm,nqtot)
     REAL(rstd) :: dulon(iim*jjm,llm)
@@ -221,5 +227,5 @@
     q = q + physics_inout%dt_phys * dq
     Temp = Temp + physics_inout%dt_phys * dTemp
-    CALL compute_temperature2theta_rhodz(ps,Temp,theta_rhodz,0)
+!    CALL compute_temperature2theta_rhodz(ps,Temp,theta_rhodz,0)
   END SUBROUTINE unpack_physics
 
Index: codes/icosagcm/trunk/src/pression.f90
===================================================================
--- codes/icosagcm/trunk/src/pression.f90	(revision 294)
+++ codes/icosagcm/trunk/src/pression.f90	(revision 295)
@@ -13,4 +13,5 @@
     INTEGER :: ind
 
+!$OMP BARRIER
     DO ind=1,ndomain
       IF (.NOT. assigned_domain(ind)) CYCLE
@@ -21,4 +22,5 @@
       CALL compute_pression(ps, p,0)
     ENDDO
+!$OMP BARRIER
   
   END SUBROUTINE pression
@@ -27,4 +29,5 @@
   USE icosa
   USE disvert_mod
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: ps(iim*jjm)
@@ -34,13 +37,15 @@
 
     IF(ap_bp_present) THEN
-    DO    l    = 1, llm+1
-      DO j=jj_begin-offset,jj_end+offset
-        DO i=ii_begin-offset,ii_end+offset
-          ij=(j-1)*iim+i
-          p(ij,l) = ap(l) + bp(l) * ps(ij)
+      DO    l    = ll_begin, ll_endp1
+!      DO    l    = 1, llm + 1
+        DO j=jj_begin-offset,jj_end+offset
+          DO i=ii_begin-offset,ii_end+offset
+            ij=(j-1)*iim+i
+            p(ij,l) = ap(l) + bp(l) * ps(ij)
+          ENDDO
         ENDDO
       ENDDO
-    ENDDO
     END IF
+
   END SUBROUTINE compute_pression
 
Index: codes/icosagcm/trunk/src/theta_rhodz.f90
===================================================================
--- codes/icosagcm/trunk/src/theta_rhodz.f90	(revision 294)
+++ codes/icosagcm/trunk/src/theta_rhodz.f90	(revision 295)
@@ -1,6 +1,25 @@
 MODULE theta2theta_rhodz_mod
+  USE field_mod
+  
+  TYPE(t_field), POINTER, SAVE  :: f_p(:)
+  TYPE(t_field), POINTER, SAVE  :: f_pks(:)
+  TYPE(t_field), POINTER, SAVE  :: f_pk(:)
+
+  PRIVATE :: f_p,f_pk,f_pks 
 
 CONTAINS
   
+  SUBROUTINE init_theta2theta_rhodz
+  USE icosa
+  USE field_mod
+  IMPLICIT NONE
+    CALL allocate_field(f_p,field_t,type_real,llm+1,name='p')
+    CALL allocate_field(f_pk,field_t,type_real,llm,name='pk')
+    CALL allocate_field(f_pks,field_t,type_real,name='pks')
+    
+  END SUBROUTINE init_theta2theta_rhodz
+
+
+
   SUBROUTINE theta_rhodz2theta(f_ps,f_theta_rhodz,f_theta)
   USE icosa
@@ -15,4 +34,5 @@
     INTEGER :: ind
 
+!$OMP BARRIER
     DO ind=1,ndomain
       IF (.NOT. assigned_domain(ind)) CYCLE
@@ -24,4 +44,5 @@
       CALL compute_theta_rhodz2theta(ps, theta_rhodz,theta,0)
     ENDDO
+!$OMP BARRIER
   
   END SUBROUTINE theta_rhodz2theta
@@ -29,4 +50,6 @@
   SUBROUTINE theta_rhodz2temperature(f_ps,f_theta_rhodz,f_temp)
   USE icosa
+  USE pression_mod
+  USE exner_mod
   IMPLICIT NONE
     TYPE(t_field), POINTER :: f_ps(:)
@@ -37,17 +60,71 @@
     REAL(rstd), POINTER :: theta_rhodz(:,:)
     REAL(rstd), POINTER :: temp(:,:)
-    INTEGER :: ind
-
-    DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
-      CALL swap_dimensions(ind)
-      CALL swap_geometry(ind)
-      ps=f_ps(ind)
+    REAL(rstd), POINTER :: p(:)
+    REAL(rstd), POINTER :: pk(:,:)
+    REAL(rstd), POINTER :: pks(:,:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+      ps=f_ps(ind)
+      p=f_p(ind)
+      pks=f_pks(ind)
+      pk=f_pk(ind)
       theta_rhodz=f_theta_rhodz(ind)
       temp=f_temp(ind)
-      CALL compute_theta_rhodz2temperature(ps, theta_rhodz,temp,0)
-    ENDDO
+
+!$OMP BARRIER
+      CALL compute_pression(ps,p,0)
+!$OMP BARRIER
+      CALL compute_exner(ps,p,pks,pk,0)
+!$OMP BARRIER
+      CALL compute_theta_rhodz2temperature(p, pk, theta_rhodz,temp,0)
+    ENDDO
+!$OMP BARRIER
   
   END SUBROUTINE theta_rhodz2temperature
+ 
+  SUBROUTINE temperature2theta_rhodz(f_ps,f_temp,f_theta_rhodz)
+  USE icosa
+  USE pression_mod
+  USE exner_mod
+  IMPLICIT NONE
+    TYPE(t_field), POINTER :: f_ps(:)
+    TYPE(t_field), POINTER :: f_theta_rhodz(:)
+    TYPE(t_field), POINTER :: f_temp(:)
+  
+    REAL(rstd), POINTER :: ps(:)
+    REAL(rstd), POINTER :: theta_rhodz(:,:)
+    REAL(rstd), POINTER :: temp(:,:)
+    REAL(rstd), POINTER :: p(:)
+    REAL(rstd), POINTER :: pk(:,:)
+    REAL(rstd), POINTER :: pks(:,:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+      ps=f_ps(ind)
+      p=f_p(ind)
+      pks=f_pks(ind)
+      pk=f_pk(ind)
+      theta_rhodz=f_theta_rhodz(ind)
+      temp=f_temp(ind)
+
+!$OMP BARRIER
+      CALL compute_pression(ps,p,0)
+!$OMP BARRIER
+      CALL compute_exner(ps,p,pks,pk,0)
+!$OMP BARRIER
+      CALL compute_temperature2theta_rhodz(p, pk, temp, theta_rhodz, 0)
+    ENDDO
+!$OMP BARRIER
+  
+  END SUBROUTINE temperature2theta_rhodz
+ 
+ 
     
   SUBROUTINE theta2theta_rhodz(f_ps,f_theta,f_theta_rhodz)
@@ -63,4 +140,5 @@
     INTEGER :: ind
 
+!$OMP BARRIER
     DO ind=1,ndomain
       IF (.NOT. assigned_domain(ind)) CYCLE
@@ -72,4 +150,5 @@
       CALL compute_theta2theta_rhodz(ps, theta, theta_rhodz,0)
     ENDDO
+!$OMP BARRIER
   
   END SUBROUTINE theta2theta_rhodz
@@ -77,5 +156,6 @@
   SUBROUTINE compute_theta2theta_rhodz(ps,theta, theta_rhodz,offset)
   USE icosa
-  USE pression_mod
+  USE disvert_mod
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: ps(iim*jjm)
@@ -84,20 +164,16 @@
     INTEGER,INTENT(IN) :: offset
     INTEGER :: i,j,ij,l
-    REAL(rstd),ALLOCATABLE,SAVE :: p(:,:)
-!$OMP THREADPRIVATE(p)
-
-    ALLOCATE( p(iim*jjm,llm+1))
-    CALL compute_pression(ps,p,offset)
-    
-    DO    l    = 1, llm
-      DO j=jj_begin-offset,jj_end+offset
-        DO i=ii_begin-offset,ii_end+offset
-          ij=(j-1)*iim+i
-          theta_rhodz(ij,l) = theta(ij,l) * (p(ij,l)-p(ij,l+1))/g
-        ENDDO
-      ENDDO
-    ENDDO
-
-    DEALLOCATE( p)
+    
+!$OMP BARRIER
+    DO    l    = ll_begin, ll_end
+      DO j=jj_begin-offset,jj_end+offset
+        DO i=ii_begin-offset,ii_end+offset
+          ij=(j-1)*iim+i
+          theta_rhodz(ij,l) = theta(ij,l) * ( (ap(l)-ap(l+1)) + ( bp(l)- bp(l+1))* ps(ij) )/g
+        ENDDO
+      ENDDO
+    ENDDO
+!$OMP BARRIER
+
 
   END SUBROUTINE compute_theta2theta_rhodz
@@ -105,5 +181,6 @@
   SUBROUTINE compute_theta_rhodz2theta(ps,theta_rhodz,theta,offset)
   USE icosa
-  USE pression_mod
+  USE disvert_mod
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: ps(iim*jjm)
@@ -112,42 +189,40 @@
     INTEGER,INTENT(IN) :: offset
     INTEGER :: i,j,ij,l
-    REAL(rstd),SAVE,ALLOCATABLE :: p(:,:)
-!$OMP THREADPRIVATE(p)
-
-    ALLOCATE( p(iim*jjm,llm+1))
-
-    CALL compute_pression(ps,p,offset)
-    
-    DO    l    = 1, llm
-      DO j=jj_begin-offset,jj_end+offset
-        DO i=ii_begin-offset,ii_end+offset
-          ij=(j-1)*iim+i
-          theta(ij,l) = theta_rhodz(ij,l) / ((p(ij,l)-p(ij,l+1))/g)
-        ENDDO
-      ENDDO
-    ENDDO
-
-    DEALLOCATE( p)
+
+!$OMP BARRIER
+    DO    l    = ll_begin, ll_end
+      DO j=jj_begin-offset,jj_end+offset
+        DO i=ii_begin-offset,ii_end+offset
+          ij=(j-1)*iim+i
+          theta(ij,l) = theta_rhodz(ij,l) / ( (ap(l)-ap(l+1)) + ( bp(l)- bp(l+1))* ps(ij) )/g
+        ENDDO
+      ENDDO
+    ENDDO
+!$OMP BARRIER
+
     
   END SUBROUTINE compute_theta_rhodz2theta
 
-  SUBROUTINE compute_theta_rhodz2temperature(ps,theta_rhodz,temp,offset)
-  USE icosa
-  USE pression_mod
-  USE exner_mod
-  IMPLICIT NONE
-    REAL(rstd),INTENT(IN) :: ps(iim*jjm)
+
+
+
+
+
+  SUBROUTINE compute_theta_rhodz2temperature(p,pk,theta_rhodz,temp,offset)
+  USE icosa
+  USE pression_mod
+  USE exner_mod
+  USE omp_para
+  IMPLICIT NONE
+    REAL(rstd),INTENT(IN) :: p(iim*jjm,llm+1)
+    REAL(rstd),INTENT(IN) :: pk(iim*jjm,llm)
     REAL(rstd),INTENT(IN) :: theta_rhodz(iim*jjm,llm)
     REAL(rstd),INTENT(OUT) :: temp(iim*jjm,llm)
     INTEGER,INTENT(IN) :: offset
     INTEGER :: i,j,ij,l
-    REAL(rstd) :: p(iim*jjm,llm+1)
-    REAL(rstd) :: pk(iim*jjm,llm)
-    REAL(rstd) :: pks(iim*jjm)
-
-    CALL compute_pression(ps,p,offset)
-    CALL compute_exner(ps,p,pks,pk,offset)
         
-    DO    l    = 1, llm
+! flush p
+!$OMP BARRIER
+    DO    l    = ll_begin, ll_end
       DO j=jj_begin-offset,jj_end+offset
         DO i=ii_begin-offset,ii_end+offset
@@ -157,25 +232,27 @@
       ENDDO
     ENDDO
+!$OMP BARRIER
+    
     
   END SUBROUTINE compute_theta_rhodz2temperature
 
-  SUBROUTINE compute_temperature2theta_rhodz(ps,temp,theta_rhodz,offset)
-  USE icosa
-  USE pression_mod
-  USE exner_mod
-  IMPLICIT NONE
-    REAL(rstd),INTENT(IN) :: ps(iim*jjm)
+  SUBROUTINE compute_temperature2theta_rhodz(p,pk,temp,theta_rhodz,offset)
+  USE icosa
+  USE pression_mod
+  USE exner_mod
+  USE omp_para
+  IMPLICIT NONE
+    REAL(rstd),INTENT(IN)  :: p(iim*jjm,llm+1)
+    REAL(rstd),INTENT(IN)  :: pk(iim*jjm,llm)
     REAL(rstd),INTENT(OUT) :: theta_rhodz(iim*jjm,llm)
-    REAL(rstd),INTENT(IN) :: temp(iim*jjm,llm)
-    INTEGER,INTENT(IN) :: offset
-    INTEGER :: i,j,ij,l
-    REAL(rstd) :: p(iim*jjm,llm+1)
-    REAL(rstd) :: pk(iim*jjm,llm)
-    REAL(rstd) :: pks(iim*jjm)
-
-    CALL compute_pression(ps,p,offset)
-    CALL compute_exner(ps,p,pks,pk,offset)
+    REAL(rstd),INTENT(IN)  :: temp(iim*jjm,llm)
+    INTEGER,INTENT(IN) :: offset
+    INTEGER :: i,j,ij,l
+
         
-    DO    l    = 1, llm
+! flush p
+!$OMP BARRIER
+
+    DO    l    = ll_begin, ll_end
       DO j=jj_begin-offset,jj_end+offset
         DO i=ii_begin-offset,ii_end+offset
@@ -185,4 +262,5 @@
       ENDDO
     ENDDO
+!$OMP BARRIER
     
   END SUBROUTINE compute_temperature2theta_rhodz
Index: codes/icosagcm/trunk/src/time.f90
===================================================================
--- codes/icosagcm/trunk/src/time.f90	(revision 294)
+++ codes/icosagcm/trunk/src/time.f90	(revision 295)
@@ -19,4 +19,7 @@
   INTEGER,SAVE    :: itau_out, itau_adv, itau_dissip, itau_physics, itaumax
 !$OMP THREADPRIVATE(itau_out, itau_adv, itau_dissip, itau_physics, itaumax)  
+
+  INTEGER,SAVE    :: itau_check_conserv
+!$OMP THREADPRIVATE(itau_check_conserv)  
   
   INTEGER,SAVE :: day_step,ndays
@@ -38,7 +41,8 @@
 
   PUBLIC create_time_counter_header, update_time_counter, close_time_counter, init_time,  &
-         dt, write_period, itau_out, itau_adv, itau_dissip, itau_physics, itaumax, & 
-day_step,ndays,jD_ref,jH_ref,day_ini,day_end,annee_ref,day_ref,an, mois, jour,heure, &
-            calend,time_style,itau0
+         dt, write_period, itau_out, itau_adv, itau_dissip, itau_physics, itaumax,  &
+         itau_check_conserv,  & 
+         day_step,ndays,jD_ref,jH_ref,day_ini,day_end,annee_ref,day_ref, &
+         an, mois, jour,heure, calend,time_style,itau0
 
 
@@ -82,11 +86,14 @@
     itau_adv=1
     CALL getin('itau_adv',itau_adv)
-    
+
     itau_dissip=1
     CALL getin('itau_dissip',itau_dissip)
-    
+
     itau_physics=1
     CALL getin('itau_physics',itau_physics)
-    
+
+    itau_check_conserv=HUGE(itau_check_conserv)
+    CALL getin('itau_check_conserv',itau_check_conserv)
+
     IF (is_mpi_root)  THEN
        PRINT *, 'itaumax=',itaumax
Index: codes/icosagcm/trunk/src/timeloop_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/timeloop_gcm.f90	(revision 294)
+++ codes/icosagcm/trunk/src/timeloop_gcm.f90	(revision 295)
@@ -39,4 +39,5 @@
   USE output_field_mod
   USE write_field
+  USE theta2theta_rhodz_mod
   IMPLICIT NONE
 
@@ -117,5 +118,5 @@
     END SELECT
 
-
+    CALL init_theta2theta_rhodz
     CALL init_dissip
     CALL init_caldyn
@@ -124,4 +125,5 @@
     CALL init_check_conserve
     CALL init_physics
+    
 
     CALL etat0(f_ps,f_mass,f_phis,f_theta_rhodz,f_u, f_q)
@@ -157,4 +159,5 @@
   USE output_field_mod
   USE write_etat0_mod
+  USE checksum_mod
   IMPLICIT NONE  
     REAL(rstd),POINTER :: q(:,:,:)
@@ -172,4 +175,5 @@
     INTEGER :: stop_clock
     INTEGER :: rate_clock
+    INTEGER :: l
     
     
@@ -178,7 +182,8 @@
 !    CALL write_restart(f_ps,f_mass,f_phis,f_theta_rhodz,f_u,f_q) 
     
+    CALL switch_omp_distrib_level
     CALL caldyn_BC(f_phis, f_wflux) ! set constant values in first/last interfaces
-
-!!$OMP BARRIER
+    
+!$OMP BARRIER
   DO ind=1,ndomain
      IF (.NOT. assigned_domain(ind)) CYCLE
@@ -189,7 +194,10 @@
         CALL compute_rhodz(.TRUE., ps, rhodz) ! save rhodz for transport scheme before dynamics update ps
      ELSE
-        rhodz(:,:)=mass(:,:)
+       DO l=ll_begin,ll_end
+         rhodz(:,l)=mass(:,l)
+       ENDDO
      END IF
   END DO
+!$OMP BARRIER
   fluxt_zero=.TRUE.
 
@@ -224,11 +232,9 @@
     ENDIF
 
-!$OMP MASTER    
-    IF (is_mpi_root) PRINT *,"It No :",It,"   t :",dt*It
-!$OMP END MASTER    
+    IF (is_master) PRINT *,"It No :",It,"   t :",dt*It
+
     IF (mod(it,itau_out)==0 ) THEN
       CALL update_time_counter(dt*it)
       CALL output_field("q",f_q)
-      CALL check_conserve(f_ps,f_dps,f_u,f_theta_rhodz,f_phis,it)  
     ENDIF
     
@@ -256,4 +262,6 @@
        
        IF(caldyn_eta==eta_mass) THEN
+!ym flush ps
+!$OMP BARRIER
           DO ind=1,ndomain
              IF (.NOT. assigned_domain(ind)) CYCLE
@@ -267,4 +275,5 @@
 !       CALL wait_message(req_mass)  
        CALL dissip(f_u,f_du,f_mass,f_phis, f_theta_rhodz,f_dtheta_rhodz)
+
 !       CALL send_message(f_mass,req_mass)
 !       CALL wait_message(req_mass)  
@@ -291,4 +300,8 @@
 
     CALL physics(it,f_phis, f_ps, f_theta_rhodz, f_u,  f_q)
+
+    IF (MOD(it,itau_check_conserv)==0) THEN
+      CALL check_conserve(f_ps,f_dps,f_u,f_theta_rhodz,f_phis,it)  
+    ENDIF
     
   ENDDO
@@ -324,5 +337,5 @@
           IF(caldyn_eta==eta_mass) THEN ! update ps
              ps=f_ps(ind) ; dps=f_dps(ind) ;              
-             IF (omp_first) THEN
+             IF (is_omp_first_level) THEN
 !$SIMD
                 DO ij=ij_begin,ij_end
@@ -376,5 +389,5 @@
       ! if mass coordinate, deal with ps first on one core
       IF(caldyn_eta==eta_mass) THEN
-         IF (omp_first) THEN
+         IF (is_omp_first_level) THEN
 
             DO ind=1,ndomain
Index: codes/icosagcm/trunk/src/transfert_mpi.f90
===================================================================
--- codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 294)
+++ codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 295)
@@ -1119,5 +1119,5 @@
 
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           
           rval2d=>field(ind)%rval2d
@@ -1152,5 +1152,5 @@
         
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           rval2d=>field(ind)%rval2d
           req=>message%request(ind)        
@@ -1192,5 +1192,5 @@
       
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
 
           dim3=size(field(ind)%rval3d,2)
@@ -1226,5 +1226,5 @@
          
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           dim3=size(field(ind)%rval3d,2)
           rval3d=>field(ind)%rval3d
@@ -1263,5 +1263,5 @@
     
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master ) CYCLE
 
           dim3=size(field(ind)%rval4d,2)
@@ -1302,5 +1302,5 @@
         
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           
           dim3=size(field(ind)%rval4d,2)
@@ -1421,5 +1421,5 @@
         
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           
           rval2d=>field(ind)%rval2d
@@ -1452,5 +1452,5 @@
         
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
 
           rval3d=>field(ind)%rval3d
@@ -1485,5 +1485,5 @@
                 
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
 
           rval4d=>field(ind)%rval4d
